diff -pruN 4.4.1-3/.circleci/config.yml 4.6.2-1/.circleci/config.yml
--- 4.4.1-3/.circleci/config.yml	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/.circleci/config.yml	2020-06-21 12:35:34.000000000 +0000
@@ -38,19 +38,19 @@ shared: &shared
                 fi
 
 jobs:
-    "mint19":
+    "mint20":
         <<: *shared
         docker:
-            - image: linuxmintd/mint19-amd64
+            - image: linuxmintd/mint20-amd64
 
-    "lmde3":
+    "lmde4":
         <<: *shared
         docker:
-            - image: linuxmintd/lmde3-amd64
+            - image: linuxmintd/lmde4-amd64
 
 workflows:
     version: 2
     build:
         jobs:
-            - "mint19"
-            - "lmde3"
+            - "mint20"
+            - "lmde4"
diff -pruN 4.4.1-3/debian/changelog 4.6.2-1/debian/changelog
--- 4.4.1-3/debian/changelog	2020-02-10 13:46:35.000000000 +0000
+++ 4.6.2-1/debian/changelog	2020-06-25 01:52:35.000000000 +0000
@@ -1,3 +1,15 @@
+cinnamon-desktop (4.6.2-1) unstable; urgency=medium
+
+  * New upstream version 4.6.2
+
+ -- Norbert Preining <norbert@preining.info>  Thu, 25 Jun 2020 10:52:35 +0900
+
+cinnamon-desktop (4.6.1-1) experimental; urgency=medium
+
+  * New upstream version 4.6.1
+
+ -- Norbert Preining <norbert@preining.info>  Thu, 11 Jun 2020 14:10:44 +0900
+
 cinnamon-desktop (4.4.1-3) unstable; urgency=medium
 
   [ Fabio Fantoni ]
diff -pruN 4.4.1-3/debian/control 4.6.2-1/debian/control
--- 4.4.1-3/debian/control	2020-02-10 13:46:35.000000000 +0000
+++ 4.6.2-1/debian/control	2020-06-25 01:52:35.000000000 +0000
@@ -37,11 +37,11 @@ Vcs-Git: https://salsa.debian.org/cinnam
 Package: cinnamon-desktop-data
 Architecture: all
 Breaks:
- cinnamon (<< 4.4),
- cinnamon-control-center (<< 4.4),
- cinnamon-screensaver (<< 4.4),
- cinnamon-session (<< 4.4),
- cinnamon-settings-daemon (<< 4.4),
+ cinnamon (<< 4.6),
+ cinnamon-control-center (<< 4.6),
+ cinnamon-screensaver (<< 4.6),
+ cinnamon-session (<< 4.6),
+ cinnamon-settings-daemon (<< 4.6),
 Multi-Arch: foreign
 Depends: python3, python3-gi, ${misc:Depends}, ${python3:Depends}
 Description: Common files for Cinnamon desktop apps
@@ -55,9 +55,9 @@ Depends: ${gir:Depends}, ${misc:Depends}
 Description: Introspection data for CinnamonDesktop
  This package contains the introspection data for CinnamonDesktop.
 Breaks:
- cinnamon-common (<< 4.4),
- cinnamon-screensaver (<< 4.4),
- gir1.2-meta-muffin-0.0 (<< 4.4),
+ cinnamon-common (<< 4.6),
+ cinnamon-screensaver (<< 4.6),
+ gir1.2-meta-muffin-0.0 (<< 4.6),
 
 Package: gir1.2-cvc-1.0
 Section: introspection
@@ -66,7 +66,7 @@ Depends: ${gir:Depends}, ${misc:Depends}
 Description: Introspection data for Cinnamon pulseaudio abstraction
  This package contains the introspection data for Cinnamon pulseaudio
  abstraction.
-Breaks: cinnamon (<< 4.4), cinnamon-settings-daemon (<< 4.4)
+Breaks: cinnamon (<< 4.6), cinnamon-settings-daemon (<< 4.6)
 
 Package: libcinnamon-desktop-dev
 Section: libdevel
@@ -83,7 +83,7 @@ Depends:
 Description: Cinnamon library for loading .desktop files - development files
  This package provides the include files and static library for the Cinnamon
  desktop library functions.
-Breaks: libmuffin-dev (<< 4.4)
+Breaks: libmuffin-dev (<< 4.6)
 
 Package: libcinnamon-desktop4
 Section: libs
@@ -96,9 +96,9 @@ Depends:
  ${shlibs:Depends},
 Recommends: hwdata (>= 0.227-1)
 Breaks:
- cinnamon-control-center (<< 4.4),
- cinnamon-settings-daemon (<< 4.4),
- libcinnamon-control-center1 (<< 4.4),
+ cinnamon-control-center (<< 4.6),
+ cinnamon-settings-daemon (<< 4.6),
+ libcinnamon-control-center1 (<< 4.6),
  nemo (<< 4.0),
 Description: Cinnamon library for loading .desktop files
  This library is used by Cinnamon to load the .desktop files.
@@ -113,4 +113,4 @@ Description: Cinnamon pulseaudio abstrac
  based library, shared between cinnamon-control-center, cinnamon-settings-daemon
  and cinnamon. It is not API stable, and it is meant to be used
  as a submodule.
-Breaks: cinnamon-settings-daemon (<< 4.4)
+Breaks: cinnamon-settings-daemon (<< 4.6)
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr.c 4.6.2-1/libcinnamon-desktop/gnome-rr.c
--- 4.4.1-3/libcinnamon-desktop/gnome-rr.c	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr.c	2020-06-21 12:35:34.000000000 +0000
@@ -27,6 +27,7 @@
 #include <config.h>
 #include <glib/gi18n-lib.h>
 #include <string.h>
+#include <math.h>
 #include <X11/Xlib.h>
 
 #include <X11/extensions/Xrandr.h>
@@ -48,6 +49,10 @@
 
 #define SERVERS_RANDR_IS_AT_LEAST_1_3(priv) (priv->rr_major_version > 1 || (priv->rr_major_version == 1 && priv->rr_minor_version >= 3))
 
+#define INTERFACE_SETTINGS "org.cinnamon.desktop.interface"
+#define GLOBAL_SCALE_FACTOR_KEY "scaling-factor"
+#define USE_UPSCALING_KEY "upscale-fractional-scaling"
+
 enum {
     SCREEN_PROP_0,
     SCREEN_PROP_GDK_SCREEN,
@@ -99,6 +104,7 @@ struct GnomeRRCrtc
     GnomeRROutput **	possible_outputs;
     int			x;
     int			y;
+    float       scale;
     
     GnomeRRRotation	current_rotation;
     GnomeRRRotation	rotations;
@@ -113,6 +119,9 @@ struct GnomeRRMode
     int			width;
     int			height;
     int			freq;		/* in mHz */
+    gboolean    doublescan;
+    gboolean    interlaced;
+    gboolean    vsync;
 };
 
 /* GnomeRRCrtc */
@@ -280,13 +289,13 @@ has_similar_mode (GnomeRROutput *output,
 
     for (i = 0; modes[i] != NULL; ++i)
     {
-	GnomeRRMode *m = modes[i];
+        GnomeRRMode *m = modes[i];
 
-	if (gnome_rr_mode_get_width (m) == width	&&
-	    gnome_rr_mode_get_height (m) == height)
-	{
-	    return TRUE;
-	}
+        if (gnome_rr_mode_get_width (m) == width	&&
+            gnome_rr_mode_get_height (m) == height)
+        {
+            return TRUE;
+        }
     }
 
     return FALSE;
@@ -300,42 +309,42 @@ gather_clone_modes (ScreenInfo *info)
 
     for (i = 0; info->outputs[i] != NULL; ++i)
     {
-	int j;
-	GnomeRROutput *output1, *output2;
+        int j;
+        GnomeRROutput *output1, *output2;
 
-	output1 = info->outputs[i];
-	
-	if (!output1->connected)
-	    continue;
-	
-	for (j = 0; output1->modes[j] != NULL; ++j)
-	{
-	    GnomeRRMode *mode = output1->modes[j];
-	    gboolean valid;
-	    int k;
-
-	    valid = TRUE;
-	    for (k = 0; info->outputs[k] != NULL; ++k)
-	    {
-		output2 = info->outputs[k];
-		
-		if (!output2->connected)
-		    continue;
-		
-		if (!has_similar_mode (output2, mode))
-		{
-		    valid = FALSE;
-		    break;
-		}
-	    }
+        output1 = info->outputs[i];
 
-	    if (valid)
-		g_ptr_array_add (result, mode);
-	}
+        if (!output1->connected)
+            continue;
+
+        for (j = 0; output1->modes[j] != NULL; ++j)
+        {
+            GnomeRRMode *mode = output1->modes[j];
+            gboolean valid;
+            int k;
+
+            valid = TRUE;
+            for (k = 0; info->outputs[k] != NULL; ++k)
+            {
+                output2 = info->outputs[k];
+
+                if (!output2->connected)
+                    continue;
+
+                if (!has_similar_mode (output2, mode))
+                {
+                    valid = FALSE;
+                    break;
+                }
+            }
+
+            if (valid)
+                g_ptr_array_add (result, mode);
+        }
     }
 
     g_ptr_array_add (result, NULL);
-    
+
     info->clone_modes = (GnomeRRMode **)g_ptr_array_free (result, FALSE);
 }
 
@@ -348,60 +357,63 @@ fill_screen_info_from_resources (ScreenI
     GPtrArray *a;
     GnomeRRCrtc **crtc;
     GnomeRROutput **output;
-
     info->resources = resources;
 
     /* We create all the structures before initializing them, so
      * that they can refer to each other.
      */
     a = g_ptr_array_new ();
+
     for (i = 0; i < resources->ncrtc; ++i)
     {
-	GnomeRRCrtc *crtc = crtc_new (info, resources->crtcs[i]);
+        GnomeRRCrtc *crtc = crtc_new (info, resources->crtcs[i]);
 
-	g_ptr_array_add (a, crtc);
+        g_ptr_array_add (a, crtc);
     }
+
     g_ptr_array_add (a, NULL);
     info->crtcs = (GnomeRRCrtc **)g_ptr_array_free (a, FALSE);
 
     a = g_ptr_array_new ();
     for (i = 0; i < resources->noutput; ++i)
     {
-	GnomeRROutput *output = output_new (info, resources->outputs[i]);
+        GnomeRROutput *output = output_new (info, resources->outputs[i]);
 
-	g_ptr_array_add (a, output);
+        g_ptr_array_add (a, output);
     }
+
     g_ptr_array_add (a, NULL);
     info->outputs = (GnomeRROutput **)g_ptr_array_free (a, FALSE);
 
     a = g_ptr_array_new ();
     for (i = 0;  i < resources->nmode; ++i)
     {
-	GnomeRRMode *mode = mode_new (info, resources->modes[i].id);
+        GnomeRRMode *mode = mode_new (info, resources->modes[i].id);
 
-	g_ptr_array_add (a, mode);
+        g_ptr_array_add (a, mode);
     }
+
     g_ptr_array_add (a, NULL);
     info->modes = (GnomeRRMode **)g_ptr_array_free (a, FALSE);
 
     /* Initialize */
     for (crtc = info->crtcs; *crtc; ++crtc)
     {
-	if (!crtc_initialize (*crtc, resources, error))
-	    return FALSE;
+        if (!crtc_initialize (*crtc, resources, error))
+            return FALSE;
     }
 
     for (output = info->outputs; *output; ++output)
     {
-	if (!output_initialize (*output, resources, error))
-	    return FALSE;
+        if (!output_initialize (*output, resources, error))
+            return FALSE;
     }
 
     for (i = 0; i < resources->nmode; ++i)
     {
-	GnomeRRMode *mode = mode_by_id (info, resources->modes[i].id);
+        GnomeRRMode *mode = mode_by_id (info, resources->modes[i].id);
 
-	mode_initialize (mode, &(resources->modes[i]));
+        mode_initialize (mode, &(resources->modes[i]));
     }
 
     gather_clone_modes (info);
@@ -734,6 +746,8 @@ gnome_rr_screen_initable_init (GInitable
     int event_base;
     int ignore;
 
+    priv->interface_settings = g_settings_new ("org.cinnamon.desktop.interface");
+
     priv->connector_type_atom = XInternAtom (dpy, "ConnectorType", FALSE);
 
     if (XRRQueryExtension (dpy, &event_base, &ignore))
@@ -788,6 +802,8 @@ gnome_rr_screen_finalize (GObject *gobje
     if (screen->priv->info)
       screen_info_free (screen->priv->info);
 
+    g_clear_object (&screen->priv->interface_settings);
+
     G_OBJECT_CLASS (gnome_rr_screen_parent_class)->finalize (gobject);
 }
 
@@ -990,6 +1006,8 @@ gnome_rr_screen_set_size (GnomeRRScreen
 {
     g_return_if_fail (GNOME_IS_RR_SCREEN (screen));
 
+    g_debug ("Setting screen size: %d x %d, %dmm x %dmm", width, height, mm_width, mm_height);
+
     gdk_error_trap_push ();
     XRRSetScreenSize (screen->priv->xdisplay, screen->priv->xroot,
 		      width, height, mm_width, mm_height);
@@ -1560,8 +1578,9 @@ out:
 static gboolean
 output_initialize (GnomeRROutput *output, XRRScreenResources *res, GError **error)
 {
-    XRROutputInfo *info = XRRGetOutputInfo (
-	DISPLAY (output), res, output->id);
+    XRROutputInfo *info = XRRGetOutputInfo (DISPLAY (output),
+                                            res,
+                                            output->id);
     GPtrArray *a;
     int i;
     
@@ -1571,14 +1590,14 @@ output_initialize (GnomeRROutput *output
     
     if (!info || !output->info)
     {
-	/* FIXME: see the comment in crtc_initialize() */
-	/* Translators: here, an "output" is a video output */
-	g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_RANDR_ERROR,
-		     _("could not get information about output %d"),
-		     (int) output->id);
-	return FALSE;
+        /* FIXME: see the comment in crtc_initialize() */
+        /* Translators: here, an "output" is a video output */
+        g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_RANDR_ERROR,
+                     _("could not get information about output %d"),
+                     (int) output->id);
+        return FALSE;
     }
-    
+
     output->name = g_strdup (info->name); /* FIXME: what is nameLen used for? */
     output->current_crtc = crtc_by_id (output->info, info->crtc);
     output->width_mm = info->mm_width;
@@ -1591,38 +1610,38 @@ output_initialize (GnomeRROutput *output
     
     for (i = 0; i < info->ncrtc; ++i)
     {
-	GnomeRRCrtc *crtc = crtc_by_id (output->info, info->crtcs[i]);
-	
-	if (crtc)
-	    g_ptr_array_add (a, crtc);
+        GnomeRRCrtc *crtc = crtc_by_id (output->info, info->crtcs[i]);
+
+        if (crtc)
+            g_ptr_array_add (a, crtc);
     }
     g_ptr_array_add (a, NULL);
     output->possible_crtcs = (GnomeRRCrtc **)g_ptr_array_free (a, FALSE);
-    
+
     /* Clones */
     a = g_ptr_array_new ();
     for (i = 0; i < info->nclone; ++i)
     {
-	GnomeRROutput *gnome_rr_output = gnome_rr_output_by_id (output->info, info->clones[i]);
-	
-	if (gnome_rr_output)
-	    g_ptr_array_add (a, gnome_rr_output);
+        GnomeRROutput *gnome_rr_output = gnome_rr_output_by_id (output->info, info->clones[i]);
+
+        if (gnome_rr_output)
+            g_ptr_array_add (a, gnome_rr_output);
     }
     g_ptr_array_add (a, NULL);
     output->clones = (GnomeRROutput **)g_ptr_array_free (a, FALSE);
-    
+
     /* Modes */
     a = g_ptr_array_new ();
     for (i = 0; i < info->nmode; ++i)
     {
-	GnomeRRMode *mode = mode_by_id (output->info, info->modes[i]);
-	
-	if (mode)
-	    g_ptr_array_add (a, mode);
+        GnomeRRMode *mode = mode_by_id (output->info, info->modes[i]);
+
+        if (mode)
+            g_ptr_array_add (a, mode);
     }
     g_ptr_array_add (a, NULL);
     output->modes = (GnomeRRMode **)g_ptr_array_free (a, FALSE);
-    
+
     output->n_preferred = info->npreferred;
     
     /* Edid data */
@@ -2135,6 +2154,62 @@ xrotation_from_rotation (GnomeRRRotation
     return result;
 }
 
+static void
+set_crtc_scale (GnomeRRCrtc *crtc,
+                GnomeRRMode *mode,
+                float        scale,
+                guint        global_scale)
+{
+    gchar *filter;
+    float real_scale;
+    int i;
+    int looks_like_w, looks_like_h;
+
+    real_scale = global_scale / scale;
+
+    looks_like_w = 0;
+    looks_like_h = 0;
+
+    if (mode != NULL)
+    {
+        looks_like_w = gnome_rr_mode_get_width (mode) * real_scale / global_scale;
+        looks_like_h = gnome_rr_mode_get_height (mode) * real_scale / global_scale;
+    }
+
+    // Fractional scales use bilinear, doubling/halving can use nearest for better quality.
+    if ((XDoubleToFixed (real_scale) % 32768) > 0)
+    {
+        filter = g_strdup ("bilinear");
+    }
+    else
+    {
+        filter = g_strdup ("nearest");
+    }
+
+    g_debug ("\n\n(xid: %lu) Transforming based on:\n"
+             "global ui scale: %d\n"
+             "requested logical scale: %.2f\n"
+             "requested logical size: %dx%d\n"
+             "xrandr transform value: %.2f (%d)\n"
+             "scaling method: %s",
+             crtc->id,
+             global_scale, scale,
+             looks_like_w, looks_like_h,
+             real_scale, XDoubleToFixed (real_scale),
+             filter);
+
+    XTransform transform =  {{
+                    { XDoubleToFixed (real_scale), 0                          , 0                    },
+                    { 0                          , XDoubleToFixed (real_scale), 0                    },
+                    { 0                          , 0                          , XDoubleToFixed (1.0) },
+    }};
+
+    XRRSetCrtcTransform (DISPLAY (crtc), crtc->id,
+                         &transform,
+                         filter,
+                         NULL, 0);
+}
+
 gboolean
 gnome_rr_crtc_set_config_with_time (GnomeRRCrtc      *crtc,
 				    guint32           timestamp,
@@ -2144,6 +2219,8 @@ gnome_rr_crtc_set_config_with_time (Gnom
 				    GnomeRRRotation   rotation,
 				    GnomeRROutput   **outputs,
 				    int               n_outputs,
+                    float             scale,
+                    guint             global_scale,
 				    GError          **error)
 {
     ScreenInfo *info;
@@ -2160,21 +2237,20 @@ gnome_rr_crtc_set_config_with_time (Gnom
     
     if (mode)
     {
-	if (x + mode->width > info->max_width
-	    || y + mode->height > info->max_height)
-	{
-	    g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_BOUNDS_ERROR,
-			 /* Translators: the "position", "size", and "maximum"
-			  * words here are not keywords; please translate them
-			  * as usual.  A CRTC is a CRT Controller (this is X terminology) */
-			 _("requested position/size for CRTC %d is outside the allowed limit: "
-			   "position=(%d, %d), size=(%d, %d), maximum=(%d, %d)"),
-			 (int) crtc->id,
-			 x, y,
-			 mode->width, mode->height,
-			 info->max_width, info->max_height);
-	    return FALSE;
-	}
+        if (x + mode->width > info->max_width || y + mode->height > info->max_height)
+        {
+            g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_BOUNDS_ERROR,
+                         /* Translators: the "position", "size", and "maximum"
+                          * words here are not keywords; please translate them
+                          * as usual.  A CRTC is a CRT Controller (this is X terminology) */
+                         _("requested position/size for CRTC %d is outside the allowed limit: "
+                         "position=(%d, %d), size=(%d, %d), maximum=(%d, %d)"),
+                         (int) crtc->id,
+                         x, y,
+                         mode->width, mode->height,
+                         info->max_width, info->max_height);
+            return FALSE;
+        }
     }
     
     output_ids = g_array_new (FALSE, FALSE, sizeof (RROutput));
@@ -2185,7 +2261,9 @@ gnome_rr_crtc_set_config_with_time (Gnom
 	    g_array_append_val (output_ids, outputs[i]->id);
     }
 
-    gdk_error_trap_push ();   
+    gdk_error_trap_push ();
+
+    set_crtc_scale (crtc, mode, scale, global_scale);
     status = XRRSetCrtcConfig (DISPLAY (crtc), info->resources, crtc->id,
 			       timestamp, 
 			       x, y,
@@ -2260,6 +2338,14 @@ gnome_rr_crtc_get_position (GnomeRRCrtc
 	*y = crtc->y;
 }
 
+float
+gnome_rr_crtc_get_scale (GnomeRRCrtc           *crtc)
+{
+    g_return_val_if_fail (crtc != NULL, MINIMUM_LOGICAL_SCALE_FACTOR);
+
+    return crtc->scale;
+}
+
 /* FIXME: merge with get_mode()? */
 GnomeRRRotation
 gnome_rr_crtc_get_current_rotation (GnomeRRCrtc *crtc)
@@ -2327,6 +2413,88 @@ crtc_copy (const GnomeRRCrtc *from)
     return to;
 }
 
+static float
+scale_from_transformation (XRRCrtcTransformAttributes *transformation)
+{
+  XTransform *xt;
+  float scale;
+
+  if (!transformation)
+    return 1.0f;
+
+  xt = &transformation->currentTransform;
+
+  if (xt->matrix[0][0] == xt->matrix[1][1])
+    scale = XFixedToDouble (xt->matrix[0][0]);
+  else
+    scale = XFixedToDouble (xt->matrix[0][0] + xt->matrix[1][1]) / 2.0;
+
+  return 1.0f / scale;
+}
+
+static float
+get_transform_scale (GnomeRRCrtc *crtc)
+{
+    XRRCrtcTransformAttributes *transform_attributes;
+    float ret;
+
+    if (!XRRGetCrtcTransform (DISPLAY (crtc), crtc->id, &transform_attributes))
+    {
+        transform_attributes = NULL;
+    }
+
+    ret = scale_from_transformation (transform_attributes);
+
+    XFree (transform_attributes);
+
+    return ret;
+}
+
+guint
+gnome_rr_screen_get_global_scale (GnomeRRScreen *screen)
+{
+    GdkScreen *gdkscreen;
+    GValue value = G_VALUE_INIT;
+    gint window_scale = 1;
+
+    gdkscreen = gdk_screen_get_default ();
+
+    g_value_init (&value, G_TYPE_INT);
+
+    if (gdk_screen_get_setting (gdkscreen, "gdk-window-scaling-factor", &value))
+    {
+        window_scale = g_value_get_int (&value);
+    }
+
+    return (guint) CLAMP (window_scale, MINIMUM_GLOBAL_SCALE_FACTOR, MAXIMUM_GLOBAL_SCALE_FACTOR);
+}
+
+guint
+gnome_rr_screen_get_global_scale_setting (GnomeRRScreen *screen)
+{
+    guint scale_factor;
+
+    scale_factor = g_settings_get_uint (screen->priv->interface_settings,
+                                        GLOBAL_SCALE_FACTOR_KEY);
+
+    return scale_factor;
+}
+
+void
+gnome_rr_screen_set_global_scale_setting (GnomeRRScreen *screen,
+                                          guint          scale_factor)
+{
+    g_settings_set_uint (screen->priv->interface_settings,
+                         GLOBAL_SCALE_FACTOR_KEY,
+                         scale_factor);
+}
+
+static float
+get_crtc_scale (GnomeRRCrtc *crtc)
+{
+    return gnome_rr_screen_get_global_scale (NULL) * get_transform_scale (crtc);
+}
+
 static gboolean
 crtc_initialize (GnomeRRCrtc        *crtc,
 		 XRRScreenResources *res,
@@ -2342,16 +2510,16 @@ crtc_initialize (GnomeRRCrtc        *crt
     
     if (!info)
     {
-	/* FIXME: We need to reaquire the screen resources */
-	/* FIXME: can we actually catch BadRRCrtc, and does it make sense to emit that? */
+        /* FIXME: We need to reaquire the screen resources */
+        /* FIXME: can we actually catch BadRRCrtc, and does it make sense to emit that? */
 
-	/* Translators: CRTC is a CRT Controller (this is X terminology).
-	 * It is *very* unlikely that you'll ever get this error, so it is
-	 * only listed for completeness. */
-	g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_RANDR_ERROR,
-		     _("could not get information about CRTC %d"),
-		     (int) crtc->id);
-	return FALSE;
+        /* Translators: CRTC is a CRT Controller (this is X terminology).
+        * It is *very* unlikely that you'll ever get this error, so it is
+        * only listed for completeness. */
+        g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_RANDR_ERROR,
+                     _("could not get information about CRTC %d"),
+                    (int) crtc->id);
+        return FALSE;
     }
     
     /* GnomeRRMode */
@@ -2364,35 +2532,41 @@ crtc_initialize (GnomeRRCrtc        *crt
     a = g_ptr_array_new ();
     for (i = 0; i < info->noutput; ++i)
     {
-	GnomeRROutput *output = gnome_rr_output_by_id (crtc->info, info->outputs[i]);
-	
-	if (output)
-	    g_ptr_array_add (a, output);
+        GnomeRROutput *output = gnome_rr_output_by_id (crtc->info, info->outputs[i]);
+
+        if (output)
+            g_ptr_array_add (a, output);
     }
+
     g_ptr_array_add (a, NULL);
     crtc->current_outputs = (GnomeRROutput **)g_ptr_array_free (a, FALSE);
-    
+
     /* Possible outputs */
     a = g_ptr_array_new ();
     for (i = 0; i < info->npossible; ++i)
     {
-	GnomeRROutput *output = gnome_rr_output_by_id (crtc->info, info->possible[i]);
-	
-	if (output)
-	    g_ptr_array_add (a, output);
+        GnomeRROutput *output = gnome_rr_output_by_id (crtc->info, info->possible[i]);
+
+        if (output)
+            g_ptr_array_add (a, output);
     }
+
     g_ptr_array_add (a, NULL);
     crtc->possible_outputs = (GnomeRROutput **)g_ptr_array_free (a, FALSE);
     
     /* Rotations */
     crtc->current_rotation = gnome_rr_rotation_from_xrotation (info->rotation);
     crtc->rotations = gnome_rr_rotation_from_xrotation (info->rotations);
-    
+    crtc->scale = get_crtc_scale (crtc);
+
     XRRFreeCrtcInfo (info);
 
     /* get an store gamma size */
     crtc->gamma_size = XRRGetCrtcGammaSize (DISPLAY (crtc), crtc->id);
 
+    g_debug ("Initialized GnomeCrtc: %d, at %d, %d, with a scale factor of %.2f (%u global scale)",
+             (int) crtc->id, crtc->x, crtc->y, crtc->scale, gnome_rr_screen_get_global_scale (NULL));
+
     return TRUE;
 }
 
@@ -2430,6 +2604,13 @@ gnome_rr_mode_get_width (GnomeRRMode *mo
     return mode->width;
 }
 
+guint
+gnome_rr_mode_get_height (GnomeRRMode *mode)
+{
+    g_return_val_if_fail (mode != NULL, 0);
+    return mode->height;
+}
+
 int
 gnome_rr_mode_get_freq (GnomeRRMode *mode)
 {
@@ -2437,11 +2618,27 @@ gnome_rr_mode_get_freq (GnomeRRMode *mod
     return (mode->freq) / 1000;
 }
 
-guint
-gnome_rr_mode_get_height (GnomeRRMode *mode)
+double
+gnome_rr_mode_get_freq_f (GnomeRRMode *mode)
 {
-    g_return_val_if_fail (mode != NULL, 0);
-    return mode->height;
+    g_return_val_if_fail (mode != NULL, 0.0);
+    return (mode->freq) / 1000.0;
+}
+
+void
+gnome_rr_mode_get_flags            (GnomeRRMode           *mode,
+                                    gboolean              *doublescan,
+                                    gboolean              *interlaced,
+                                    gboolean              *vsync)
+{
+    g_return_if_fail (mode != NULL);
+
+    if (doublescan)
+        *doublescan = mode->doublescan;
+    if (interlaced)
+        *interlaced = mode->interlaced;
+    if (vsync)
+        *vsync = mode->vsync;
 }
 
 static void
@@ -2453,7 +2650,10 @@ mode_initialize (GnomeRRMode *mode, XRRM
     mode->name = g_strdup (info->name);
     mode->width = info->width;
     mode->height = info->height;
-    mode->freq = ((info->dotClock / (double)info->hTotal) / info->vTotal + 0.5) * 1000;
+    mode->freq = info->dotClock / ((float)info->hTotal * info->vTotal) * 1000;
+    mode->doublescan = (info->modeFlags & RR_DoubleScan);
+    mode->interlaced = (info->modeFlags & RR_Interlace);
+    mode->vsync = (info->modeFlags & RR_VSyncPositive);
 }
 
 static GnomeRRMode *
@@ -2549,3 +2749,271 @@ gnome_rr_crtc_get_gamma (GnomeRRCrtc *cr
     return TRUE;
 }
 
+#define SCALE_FACTORS_PER_INTEGER 4
+#define SCALE_FACTORS_STEPS (1.0 / (float) SCALE_FACTORS_PER_INTEGER)
+
+/* The minimum resolution at which we turn on a window-scale of 2 */
+#define HIDPI_LIMIT 192
+#define HIDPI_MIN_SCALED_HEIGHT 720
+
+/* The minimum screen height at which we turn on a window-scale of 2;
+ * below this there just isn't enough vertical real estate for GNOME
+ * apps to work, and it's better to just be tiny */
+#define HIDPI_MIN_HEIGHT 1500
+
+static gboolean
+is_logical_size_large_enough (int width,
+                              int height)
+{
+  return height > HIDPI_MIN_SCALED_HEIGHT;
+}
+
+static gboolean
+is_scale_valid_for_size (float width,
+                         float height,
+                         float scale)
+{
+  return scale >= MINIMUM_LOGICAL_SCALE_FACTOR &&
+         scale <= MAXIMUM_LOGICAL_SCALE_FACTOR;
+}
+
+static float
+get_closest_scale_factor_for_resolution (float width,
+                                         float height,
+                                         float scale)
+{
+  unsigned int i, j;
+  float scaled_h;
+  float scaled_w;
+  float best_scale;
+  int base_scaled_w;
+  gboolean found_one;
+
+  best_scale = 0;
+
+  if (!is_scale_valid_for_size (width, height, scale))
+    goto out;
+
+  if (fmodf (width, scale) == 0.0 && fmodf (height, scale) == 0.0)
+    return scale;
+
+  i = 0;
+  found_one = FALSE;
+  base_scaled_w = floorf (width / scale);
+  do
+    {
+      for (j = 0; j < 2; j++)
+        {
+          float current_scale;
+          int offset = i * (j ? 1 : -1);
+
+          scaled_w = base_scaled_w + offset;
+          current_scale = width / scaled_w;
+          scaled_h = height / current_scale;
+
+          if (current_scale >= scale + SCALE_FACTORS_STEPS ||
+              current_scale <= scale - SCALE_FACTORS_STEPS ||
+              current_scale < MINIMUM_LOGICAL_SCALE_FACTOR ||
+              current_scale > MAXIMUM_LOGICAL_SCALE_FACTOR)
+            {
+              goto out;
+            }
+
+          if (floorf (scaled_h) == scaled_h)
+            {
+              found_one = TRUE;
+
+              if (fabsf (current_scale - scale) < fabsf (best_scale - scale))
+                best_scale = current_scale;
+            }
+        }
+
+      i++;
+    }
+  while (!found_one);
+
+out:
+  return best_scale;
+}
+
+float *
+gnome_rr_screen_calculate_supported_scales (GnomeRRScreen     *screen,
+                                            int                width,
+                                            int                height,
+                                            int               *n_supported_scales)
+{
+  unsigned int i, j;
+  GArray *supported_scales;
+
+  supported_scales = g_array_new (FALSE, FALSE, sizeof (float));
+
+  for (i = floorf (MINIMUM_LOGICAL_SCALE_FACTOR);
+       i <= ceilf (MAXIMUM_LOGICAL_SCALE_FACTOR);
+       i++)
+    {
+      for (j = 0; j < SCALE_FACTORS_PER_INTEGER; j++)
+        {
+          float scale;
+          float scale_value = i + j * SCALE_FACTORS_STEPS;
+
+          scale = get_closest_scale_factor_for_resolution (width,
+                                                           height,
+                                                           scale_value);
+          if (scale > 0.0f)
+            g_array_append_val (supported_scales, scale);
+        }
+    }
+
+  if (supported_scales->len == 0)
+    {
+      float fallback_scale;
+
+      fallback_scale = MINIMUM_LOGICAL_SCALE_FACTOR;
+      g_array_append_val (supported_scales, fallback_scale);
+    }
+
+  *n_supported_scales = supported_scales->len;
+  return (float *) g_array_free (supported_scales, FALSE);
+}
+
+static void
+get_real_monitor_size (GnomeRRScreen *screen,
+                       GdkMonitor    *monitor,
+                       gint           monitor_index,
+                       gint          *width,
+                       gint          *height)
+{
+    GnomeRROutput **outputs;
+    XID output_id;
+    gint i;
+
+    *width = 0;
+    *height = 0;
+
+    output_id = gdk_x11_screen_get_monitor_output (gdk_screen_get_default (), monitor_index);
+    outputs = gnome_rr_screen_list_outputs (screen);
+
+    for (i = 0; outputs[i] != NULL; i++)
+    {
+        GnomeRROutput *output = outputs[i];
+
+        if (gnome_rr_output_get_id (output) == output_id)
+        {
+            GnomeRRMode *mode = gnome_rr_output_get_current_mode (output);
+
+            if (mode == NULL)
+            {
+                mode = gnome_rr_output_get_preferred_mode (output);
+            }
+
+            if (mode != NULL)
+            {
+                *width = gnome_rr_mode_get_width (mode);
+                *height = gnome_rr_mode_get_height (mode);
+            }
+
+            break;
+        }
+    }
+
+    if (*width == 0 || *height == 0)
+    {
+        GdkRectangle rect;
+        gdk_monitor_get_geometry (monitor, &rect);
+
+        *width = rect.width;
+        *height = rect.height;
+    }
+}
+
+guint
+gnome_rr_screen_calculate_best_global_scale (GnomeRRScreen *screen,
+                                             gint           index)
+{
+    guint window_scale;
+    GdkDisplay *display;
+    GdkMonitor *monitor;
+    int width_mm, height_mm;
+    int monitor_scale;
+    double dpi_x, dpi_y;
+    int real_width, real_height;
+
+    display = gdk_display_get_default ();
+    
+    if (index == -1)
+    {
+        monitor = gdk_display_get_primary_monitor (display);
+
+        index = 0;
+    }
+    else
+    {
+        if ((index >= 0) && (index < gdk_display_get_n_monitors (display)))
+        {
+            monitor = gdk_display_get_monitor (display, index);
+        }
+        else
+        {
+            g_warning ("Invalid monitor index provided (%d)", index);
+            return 1;
+        }
+    }
+
+    /* GdkMonitor geometry is affected by any active current transformation/scaling!!!!
+     * So if I have 2x global scale, and a transform on a 1080 monitor down to 540, that's
+     * what gdk_monitor_get_geometry() returns.  We actually have to get the dimensions from
+     * the current RRMode for the given monitor.
+     */
+    get_real_monitor_size (screen, monitor, index, &real_width, &real_height);
+
+
+    width_mm = gdk_monitor_get_width_mm (monitor);
+    height_mm = gdk_monitor_get_height_mm (monitor);
+    monitor_scale = gdk_monitor_get_scale_factor (monitor);
+
+    window_scale = 1;
+
+    g_debug ("Calculating best global scale for monitor %d. Physical size: %dmm x %dmm,"
+             " REAL pixel size: %d x %d.  Current global scale: %d, reported monitor scale: %d",
+             index, width_mm, height_mm, real_width, real_height, gnome_rr_screen_get_global_scale (NULL), monitor_scale);
+
+    if (real_height < HIDPI_MIN_HEIGHT)
+    {
+        g_debug ("REAL height of %d for monitor %d is less than %d, so the recommended scale will be 1", real_height, index, HIDPI_MIN_HEIGHT);
+        goto out;
+    }
+
+    /* Some monitors/TV encode the aspect ratio (16/9 or 16/10) instead of the physical size */
+    if ((width_mm == 160 && height_mm == 90) ||
+        (width_mm == 160 && height_mm == 100) ||
+        (width_mm == 16 && height_mm == 9) ||
+        (width_mm == 16 && height_mm == 10) ||
+        (width_mm == 0 || height_mm == 0))
+    {
+        g_debug ("Aspect ratio instead of physical dimensions were encoded as the physical size, or the physical"
+                 " size was not set. Unable to reliably calculate the recommended scale, returning 1");
+        goto out;
+    }
+
+    if (width_mm > 0 && height_mm > 0) {
+            dpi_x = (double) real_width / (width_mm / 25.4);
+            dpi_y = (double) real_height / (height_mm / 25.4);
+            /* We don't completely trust these values so both must be high, and never pick higher ratio than
+              2 automatically */
+            if (dpi_x > HIDPI_LIMIT && dpi_y > HIDPI_LIMIT)
+            {
+                g_debug ("The REAL monitor DPI of %.1f x %.1f exceeds the cutoff of %d x %d, recommended scale will be 2",
+                         dpi_x, dpi_y, HIDPI_LIMIT, HIDPI_LIMIT);
+
+                window_scale = 2;
+            }
+            else
+            {
+                g_debug ("The REAL monitor DPI of %.1f x %.1f does not meet the cutoff of %d x %d, recommended scale will be 1",
+                         dpi_x, dpi_y, HIDPI_LIMIT, HIDPI_LIMIT);
+            }
+    }
+
+out:
+    return window_scale;
+}
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr-config.c 4.6.2-1/libcinnamon-desktop/gnome-rr-config.c
--- 4.4.1-3/libcinnamon-desktop/gnome-rr-config.c	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr-config.c	2020-06-21 12:35:34.000000000 +0000
@@ -30,6 +30,7 @@
 #include <glib/gi18n-lib.h>
 #include <stdlib.h>
 #include <string.h>
+#include <math.h>
 #include <glib.h>
 #include <glib/gstdio.h>
 
@@ -41,9 +42,11 @@
 #include "edid.h"
 #include "gnome-rr-private.h"
 
-#define CONFIG_INTENDED_BASENAME "monitors.xml"
-#define CONFIG_BACKUP_BASENAME "monitors.xml.backup"
+#define CONFIG_INTENDED_BASENAME "cinnamon-monitors.xml"
+#define CONFIG_BACKUP_BASENAME "cinnamon-monitors.xml.backup"
+#define CONFIG_LEGACY_BASENAME "monitors.xml"
 
+#define BASE_SCALE_NOT_CONFIGURED 0
 /* Look for DPI_FALLBACK in:
  * http://git.gnome.org/browse/gnome-settings-daemon/tree/plugins/xsettings/gsd-xsettings-manager.c
  * for the reasoning */
@@ -84,10 +87,12 @@ typedef struct CrtcAssignment CrtcAssign
 
 static gboolean         crtc_assignment_apply (CrtcAssignment   *assign,
 					       guint32           timestamp,
-					       GError          **error);
-static CrtcAssignment  *crtc_assignment_new   (GnomeRRScreen      *screen,
-					       GnomeRROutputInfo **outputs,
-					       GError            **error);
+					       GError          **error,
+                           guint            *global_scale);
+static CrtcAssignment  *crtc_assignment_new   (GnomeRRConfig *config,
+                                               GnomeRRScreen      *screen,
+                                               GnomeRROutputInfo **outputs,
+                                               GError            **error);
 static void             crtc_assignment_free  (CrtcAssignment   *assign);
 
 enum {
@@ -117,12 +122,18 @@ parse_int (const char *text)
     return strtol (text, NULL, 0);
 }
 
-static guint
-parse_uint (const char *text)
+static guint64
+parse_uint64 (const char *text)
 {
     return strtoul (text, NULL, 0);
 }
 
+static double
+parse_double (const char *text)
+{
+    return strtod (text, NULL);
+}
+
 static gboolean
 stack_is (Parser *parser,
 	  const char *s1,
@@ -209,7 +220,7 @@ handle_start_element (GMarkupParseContex
     else if (strcmp (name, "configuration") == 0)
     {
 	g_assert (parser->configuration == NULL);
-	
+
 	parser->configuration = g_object_new (GNOME_TYPE_RR_CONFIG, NULL);
 	parser->configuration->priv->clone = FALSE;
 	parser->configuration->priv->outputs = NULL;
@@ -272,7 +283,7 @@ handle_text (GMarkupParseContext *contex
 	     GError             **err)
 {
     Parser *parser = user_data;
-    
+
     if (stack_is (parser, "vendor", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
     {
 	parser->output->priv->connected = TRUE;
@@ -285,6 +296,10 @@ handle_text (GMarkupParseContext *contex
 	if (strcmp (text, "yes") == 0)
 	    parser->configuration->priv->clone = TRUE;
     }
+    else if (stack_is (parser, "base_scale", "configuration", TOPLEVEL_ELEMENT, NULL))
+    {
+        parser->configuration->priv->base_scale = (guint) parse_uint64 (text);
+    }
     else if (stack_is (parser, "product", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
     {
 	parser->output->priv->connected = TRUE;
@@ -295,7 +310,7 @@ handle_text (GMarkupParseContext *contex
     {
 	parser->output->priv->connected = TRUE;
 
-	parser->output->priv->serial = parse_uint (text);
+	parser->output->priv->serial = parse_uint64 (text);
     }
     else if (stack_is (parser, "width", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
     {
@@ -315,6 +330,12 @@ handle_text (GMarkupParseContext *contex
 
 	parser->output->priv->y = parse_int (text);
     }
+    else if (stack_is (parser, "scale", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
+    {
+    parser->output->priv->on = TRUE;
+
+    parser->output->priv->scale = parse_double (text);
+    }
     else if (stack_is (parser, "height", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
     {
 	parser->output->priv->on = TRUE;
@@ -325,7 +346,7 @@ handle_text (GMarkupParseContext *contex
     {
 	parser->output->priv->on = TRUE;
 
-	parser->output->priv->rate = parse_int (text);
+	parser->output->priv->rate = parse_double (text);
     }
     else if (stack_is (parser, "rotation", "output", "configuration", TOPLEVEL_ELEMENT, NULL))
     {
@@ -412,6 +433,32 @@ parser_free (Parser *parser)
     g_free (parser);
 }
 
+static void
+check_auto_scaling (GnomeRRConfig **configs)
+{
+    GnomeRRConfig *config;
+    gint i;
+
+    if (configs == NULL)
+    {
+        return;
+    }
+
+    i = 0;
+    config = configs[i];
+
+    while (config != NULL)
+    {
+        if (config->priv->base_scale == BASE_SCALE_NOT_CONFIGURED)
+        {
+            config->priv->auto_scale = TRUE;
+            config->priv->base_scale = gnome_rr_screen_get_global_scale (NULL);
+        }
+
+        config = configs[++i];
+    }
+}
+
 static GnomeRRConfig **
 configurations_read_from_file (const gchar *filename, GError **error)
 {
@@ -439,7 +486,7 @@ configurations_read_from_file (const gch
     }
 
     g_assert (parser->outputs);
-    
+
     g_ptr_array_add (parser->configurations, NULL);
     result = (GnomeRRConfig **)g_ptr_array_free (parser->configurations, FALSE);
     parser->configurations = g_ptr_array_new ();
@@ -448,6 +495,8 @@ configurations_read_from_file (const gch
 out:
     parser_free (parser);
 
+    check_auto_scaling (result);
+
     return result;
 }
 
@@ -457,6 +506,8 @@ gnome_rr_config_init (GnomeRRConfig *sel
     self->priv = G_TYPE_INSTANCE_GET_PRIVATE (self, GNOME_TYPE_RR_CONFIG, GnomeRRConfigPrivate);
 
     self->priv->clone = FALSE;
+    self->priv->base_scale = BASE_SCALE_NOT_CONFIGURED;
+    self->priv->auto_scale = FALSE;
     self->priv->screen = NULL;
     self->priv->outputs = NULL;
 }
@@ -512,6 +563,11 @@ gnome_rr_config_load_current (GnomeRRCon
     rr_outputs = gnome_rr_screen_list_outputs (config->priv->screen);
 
     config->priv->clone = FALSE;
+    config->priv->base_scale = gnome_rr_screen_get_global_scale (config->priv->screen);
+    if (gnome_rr_screen_get_global_scale_setting (config->priv->screen) == 0)
+    {
+        config->priv->auto_scale = TRUE;
+    }
     
     for (i = 0; rr_outputs[i] != NULL; ++i)
     {
@@ -530,8 +586,12 @@ gnome_rr_config_load_current (GnomeRRCon
 	    output->priv->y = -1;
 	    output->priv->width = -1;
 	    output->priv->height = -1;
-	    output->priv->rate = -1;
+	    output->priv->rate = -1.0f;
+        output->priv->scale = MINIMUM_LOGICAL_SCALE_FACTOR;
 	    output->priv->rotation = GNOME_RR_ROTATION_0;
+        output->priv->doublescan = FALSE;
+        output->priv->interlaced = FALSE;
+        output->priv->interlaced = FALSE;
 	}
 	else
 	{
@@ -573,9 +633,16 @@ gnome_rr_config_load_current (GnomeRRCon
 		gnome_rr_crtc_get_position (crtc, &output->priv->x, &output->priv->y);
 		output->priv->width = gnome_rr_mode_get_width (mode);
 		output->priv->height = gnome_rr_mode_get_height (mode);
-		output->priv->rate = gnome_rr_mode_get_freq (mode);
+		output->priv->rate = gnome_rr_mode_get_freq_f (mode);
 		output->priv->rotation = gnome_rr_crtc_get_current_rotation (crtc);
 
+        output->priv->scale = gnome_rr_crtc_get_scale (crtc);
+
+        gnome_rr_mode_get_flags (mode,
+                                 &output->priv->doublescan,
+                                 &output->priv->interlaced,
+                                 &output->priv->vsync);
+
 		if (output->priv->x == 0 && output->priv->y == 0) {
 			if (clone_width == -1) {
 				clone_width = output->priv->width;
@@ -659,7 +726,7 @@ gnome_rr_config_load_current (GnomeRRCon
 	if (output->priv->connected && !output->priv->on)
 	{
 	    output->priv->x = last_x;
-	    last_x = output->priv->x + output->priv->width;
+	    last_x = output->priv->x + (output->priv->width * config->priv->base_scale);
 	}
     }
     
@@ -668,6 +735,41 @@ gnome_rr_config_load_current (GnomeRRCon
     return TRUE;
 }
 
+static void
+ensure_scale_factor (GnomeRRConfig     *config_from_file,
+                     GnomeRROutputInfo *info_from_file)
+{
+    /* Loading an old config for the first time, there probably won't be any
+     * scale factor.  If this happens, give it the matching current output's
+     * scale factor (what actual 'is' right now) - to maintain their existing
+     * configuration. */
+    int k;
+
+    for (k = 0; config_from_file->priv->outputs[k] != NULL; ++k)
+    {
+        if (config_from_file->priv->auto_scale)
+        {
+            info_from_file->priv->scale = (float) config_from_file->priv->base_scale;
+            continue;
+        }
+
+        gchar *current_output_name, *new_output_name;
+
+        current_output_name = config_from_file->priv->outputs[k]->priv->name;
+        new_output_name = info_from_file->priv->name;
+
+        if (g_strcmp0 (current_output_name, new_output_name) == 0)
+        {
+            info_from_file->priv->scale = config_from_file->priv->outputs[k]->priv->scale;
+        }
+    }
+
+    if (info_from_file->priv->scale == 0)
+    {
+        info_from_file->priv->scale = MINIMUM_LOGICAL_SCALE_FACTOR;
+    }
+}
+
 gboolean
 gnome_rr_config_load_filename (GnomeRRConfig *result, const char *filename, GError **error)
 {
@@ -691,24 +793,31 @@ gnome_rr_config_load_filename (GnomeRRCo
 	{
 	    if (gnome_rr_config_match (configs[i], current))
 	    {
-		int j;
-		GPtrArray *array;
-		result->priv->clone = configs[i]->priv->clone;
-
-		array = g_ptr_array_new ();
-		for (j = 0; configs[i]->priv->outputs[j] != NULL; j++) {
-                    g_object_ref (configs[i]->priv->outputs[j]);
-		    g_ptr_array_add (array, configs[i]->priv->outputs[j]);
-		}
-		g_ptr_array_add (array, NULL);
-		result->priv->outputs = (GnomeRROutputInfo **) g_ptr_array_free (array, FALSE);
+            int j;
+            GPtrArray *array;
+            result->priv->clone = configs[i]->priv->clone;
+            result->priv->auto_scale = configs[i]->priv->auto_scale;
+            result->priv->base_scale = configs[i]->priv->base_scale;
+
+            array = g_ptr_array_new ();
+            for (j = 0; configs[i]->priv->outputs[j] != NULL; j++) {
+                int k;
+                g_object_ref (configs[i]->priv->outputs[j]);
+                g_ptr_array_add (array, configs[i]->priv->outputs[j]);
 
-		found = TRUE;
-		break;
-	    }
-	    g_object_unref (configs[i]);
-	}
-	g_free (configs);
+                ensure_scale_factor (configs[i], configs[i]->priv->outputs[j]);
+            }
+            g_ptr_array_add (array, NULL);
+            result->priv->outputs = (GnomeRROutputInfo **) g_ptr_array_free (array, FALSE);
+
+            found = TRUE;
+            break;
+        }
+
+        g_object_unref (configs[i]);
+    }
+
+    g_free (configs);
 
 	if (!found)
 	    g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_NO_MATCHING_CONFIG,
@@ -759,6 +868,16 @@ gnome_rr_config_new_stored (GnomeRRScree
 
     success = gnome_rr_config_load_filename (self, filename, error);
 
+    if (!success)
+    {
+        g_clear_error (error);
+        g_debug ("existing monitor config (%s) not found.  Looking for legacy configuration (monitors.xml)", filename);
+        g_free (filename);
+        filename = gnome_rr_config_get_legacy_filename ();
+
+        success = gnome_rr_config_load_filename (self, filename, error);
+    }
+
     g_free (filename);
 
     if (success)
@@ -866,6 +985,9 @@ output_equal (GnomeRROutputInfo *output1
 	
 	if (output1->priv->rotation != output2->priv->rotation)
 	    return FALSE;
+
+    if (output1->priv->scale != output2->priv->scale)
+        return FALSE;
     }
 
     return TRUE;
@@ -921,6 +1043,16 @@ gnome_rr_config_equal (GnomeRRConfig  *c
     g_return_val_if_fail (GNOME_IS_RR_CONFIG (c1), FALSE);
     g_return_val_if_fail (GNOME_IS_RR_CONFIG (c2), FALSE);
 
+    if (c1->priv->auto_scale != c2->priv->auto_scale)
+    {
+        return FALSE;
+    }
+
+    if (c1->priv->base_scale != c2->priv->base_scale)
+    {
+        return FALSE;
+    }
+
     for (i = 0; c1->priv->outputs[i] != NULL; ++i)
     {
 	GnomeRROutputInfo *output1 = c1->priv->outputs[i];
@@ -967,6 +1099,8 @@ make_outputs (GnomeRRConfig *config)
 	    new->priv->rotation = first_on->priv->rotation;
 	    new->priv->x = 0;
 	    new->priv->y = 0;
+        new->priv->scale = first_on->priv->scale;
+        new->priv->rate = 60.0f;
 	}
 
 	g_ptr_array_add (outputs, new);
@@ -992,7 +1126,7 @@ gnome_rr_config_applicable (GnomeRRConfi
     g_return_val_if_fail (error == NULL || *error == NULL, FALSE);
 
     outputs = make_outputs (configuration);
-    assign = crtc_assignment_new (screen, outputs, error);
+    assign = crtc_assignment_new (configuration, screen, outputs, error);
 
     if (assign)
     {
@@ -1033,6 +1167,13 @@ gnome_rr_config_get_intended_filename (v
     return g_build_filename (g_get_user_config_dir (), CONFIG_INTENDED_BASENAME, NULL);
 }
 
+char *
+gnome_rr_config_get_legacy_filename (void)
+{
+    ensure_config_directory ();
+    return g_build_filename (g_get_user_config_dir (), CONFIG_LEGACY_BASENAME, NULL);
+}
+
 static const char *
 get_rotation_name (GnomeRRRotation r)
 {
@@ -1075,6 +1216,11 @@ emit_configuration (GnomeRRConfig *confi
     g_string_append_printf (string, "  <configuration>\n");
 
     g_string_append_printf (string, "      <clone>%s</clone>\n", yes_no (config->priv->clone));
+
+    if (!config->priv->auto_scale)
+    {
+        g_string_append_printf (string, "      <base_scale>%d</base_scale>\n", config->priv->base_scale);
+    }
     
     for (j = 0; config->priv->outputs[j] != NULL; ++j)
     {
@@ -1101,12 +1247,19 @@ emit_configuration (GnomeRRConfig *confi
 	    g_string_append_printf (
 		string, "          <height>%d</height>\n", output->priv->height);
 	    g_string_append_printf (
-		string, "          <rate>%d</rate>\n", output->priv->rate);
+		string, "          <rate>%f</rate>\n", output->priv->rate);
 	    g_string_append_printf (
 		string, "          <x>%d</x>\n", output->priv->x);
 	    g_string_append_printf (
 		string, "          <y>%d</y>\n", output->priv->y);
-	    g_string_append_printf (
+
+        if (!config->priv->auto_scale)
+        {
+            g_string_append_printf (
+            string, "          <scale>%f</scale>\n", output->priv->scale);
+        }
+
+        g_string_append_printf (
 		string, "          <rotation>%s</rotation>\n", get_rotation_name (output->priv->rotation));
 	    g_string_append_printf (
 		string, "          <reflect_x>%s</reflect_x>\n", get_reflect_x (output->priv->rotation));
@@ -1294,6 +1447,7 @@ gnome_rr_config_apply_with_time (GnomeRR
     GnomeRROutputInfo **outputs;
     gboolean result = FALSE;
     int i;
+    guint global_scale;
 
     g_return_val_if_fail (GNOME_IS_RR_CONFIG (config), FALSE);
     g_return_val_if_fail (GNOME_IS_RR_SCREEN (screen), FALSE);
@@ -1302,15 +1456,17 @@ gnome_rr_config_apply_with_time (GnomeRR
 
     outputs = make_outputs (config);
 
-    assignment = crtc_assignment_new (screen, outputs, error);
+    assignment = crtc_assignment_new (config, screen, outputs, error);
 
     for (i = 0; outputs[i] != NULL; i++)
 	g_object_unref (outputs[i]);
     g_free (outputs);
-    
+
+    global_scale = config->priv->base_scale;
+
     if (assignment)
     {
-	if (crtc_assignment_apply (assignment, timestamp, error))
+	if (crtc_assignment_apply (assignment, timestamp, error, &global_scale))
 	    result = TRUE;
 
 	crtc_assignment_free (assignment);
@@ -1320,6 +1476,12 @@ gnome_rr_config_apply_with_time (GnomeRR
 	gdk_error_trap_pop (); // ignore errors
     }
 
+    if (result == TRUE)
+    {
+        gnome_rr_screen_set_global_scale_setting (screen,
+                                                  config->priv->auto_scale ? 0 : global_scale);
+    }
+
     return result;
 }
 
@@ -1414,6 +1576,45 @@ gnome_rr_config_set_clone (GnomeRRConfig
     self->priv->clone = clone;
 }
 
+guint
+gnome_rr_config_get_base_scale (GnomeRRConfig *self)
+{
+    g_return_val_if_fail (GNOME_IS_RR_CONFIG (self), MINIMUM_GLOBAL_SCALE_FACTOR);
+
+    if (self->priv->auto_scale)
+    {
+        return gnome_rr_screen_get_global_scale (self->priv->screen);
+    }
+
+    return self->priv->base_scale;
+}
+
+void
+gnome_rr_config_set_base_scale (GnomeRRConfig *self,
+                                guint base_scale)
+{
+    g_return_if_fail (GNOME_IS_RR_CONFIG (self) || base_scale < MINIMUM_GLOBAL_SCALE_FACTOR);
+
+    self->priv->base_scale = base_scale;
+}
+
+gboolean
+gnome_rr_config_get_auto_scale (GnomeRRConfig *self)
+{
+    g_return_val_if_fail (GNOME_IS_RR_CONFIG (self), TRUE);
+
+    return self->priv->auto_scale;
+}
+
+void
+gnome_rr_config_set_auto_scale (GnomeRRConfig *self,
+                                gboolean       auto_scale)
+{
+    g_return_if_fail (GNOME_IS_RR_CONFIG (self));
+
+    self->priv->auto_scale = auto_scale;
+}
+
 /*
  * CRTC assignment
  */
@@ -1424,6 +1625,7 @@ struct CrtcInfo
     GnomeRRMode    *mode;
     int        x;
     int        y;
+    float      scale;
     GnomeRRRotation rotation;
     GPtrArray *outputs;
 };
@@ -1459,102 +1661,108 @@ crtc_assignment_assign (CrtcAssignment
 			int               x,
 			int               y,
 			GnomeRRRotation   rotation,
-                        gboolean          primary,
+            gboolean          primary,
+            float             scale,
 			GnomeRROutput    *output,
 			GError          **error)
 {
     CrtcInfo *info = g_hash_table_lookup (assign->info, crtc);
     guint32 crtc_id;
     const char *output_name;
-
     crtc_id = gnome_rr_crtc_get_id (crtc);
     output_name = gnome_rr_output_get_name (output);
 
     if (!gnome_rr_crtc_can_drive_output (crtc, output))
     {
-	g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
-		     _("CRTC %d cannot drive output %s"), crtc_id, output_name);
-	return FALSE;
+        g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
+                     _("CRTC %d cannot drive output %s"), crtc_id, output_name);
+        return FALSE;
     }
 
     if (!gnome_rr_output_supports_mode (output, mode))
     {
-	g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
-		     _("output %s does not support mode %dx%d@%dHz"),
-		     output_name,
-		     gnome_rr_mode_get_width (mode),
-		     gnome_rr_mode_get_height (mode),
-		     gnome_rr_mode_get_freq (mode));
-	return FALSE;
+        g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
+                     _("output %s does not support mode %dx%d@%dHz"),
+                     output_name,
+                     gnome_rr_mode_get_width (mode),
+                     gnome_rr_mode_get_height (mode),
+                     gnome_rr_mode_get_freq (mode));
+        return FALSE;
     }
 
     if (!gnome_rr_crtc_supports_rotation (crtc, rotation))
     {
-	g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
-		     _("CRTC %d does not support rotation=%s"),
-		     crtc_id,
-		     get_rotation_name (rotation));
-	return FALSE;
+        g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
+                     _("CRTC %d does not support rotation=%s"),
+                     crtc_id,
+                     get_rotation_name (rotation));
+        return FALSE;
     }
 
     if (info)
     {
-	if (!(info->mode == mode	&&
-	      info->x == x		&&
-	      info->y == y		&&
-	      info->rotation == rotation))
-	{
-	    g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
-			 _("output %s does not have the same parameters as another cloned output:\n"
-			   "existing mode = %d, new mode = %d\n"
-			   "existing coordinates = (%d, %d), new coordinates = (%d, %d)\n"
-			   "existing rotation = %s, new rotation = %s"),
-			 output_name,
-			 gnome_rr_mode_get_id (info->mode), gnome_rr_mode_get_id (mode),
-			 info->x, info->y,
-			 x, y,
-			 get_rotation_name (info->rotation), get_rotation_name (rotation));
-	    return FALSE;
-	}
+        if (!(info->mode == mode	&&
+              info->x == x		&&
+              info->y == y		&&
+              info->scale == scale &&
+              info->rotation == rotation))
+        {
+            g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
+                         _("output %s does not have the same parameters as another cloned output:\n"
+                         "existing mode = %d, new mode = %d\n"
+                         "existing coordinates = (%d, %d), new coordinates = (%d, %d)\n"
+                         "existing rotation = %s, new rotation = %s"
+                         "existing scale = %.2f, new scale = %.2f"),
+                         output_name,
+                         gnome_rr_mode_get_id (info->mode), gnome_rr_mode_get_id (mode),
+                         info->x, info->y,
+                         x, y,
+                         get_rotation_name (info->rotation), get_rotation_name (rotation),
+                         info->scale, scale);
+            return FALSE;
+        }
 
-	if (!can_clone (info, output))
-	{
-	    g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
-			 _("cannot clone to output %s"),
-			 output_name);
-	    return FALSE;
-	}
+        if (!can_clone (info, output))
+        {
+            g_set_error (error, GNOME_RR_ERROR, GNOME_RR_ERROR_CRTC_ASSIGNMENT,
+                         _("cannot clone to output %s"),
+                         output_name);
+            return FALSE;
+        }
 
-	g_ptr_array_add (info->outputs, output);
+        g_ptr_array_add (info->outputs, output);
 
-	if (primary && !assign->primary)
-	{
-	    assign->primary = output;
-	}
+        if (primary && !assign->primary)
+        {
+            assign->primary = output;
+        }
 
-	return TRUE;
+        return TRUE;
     }
     else
-    {	
-	CrtcInfo *info = g_new0 (CrtcInfo, 1);
-	
-	info->mode = mode;
-	info->x = x;
-	info->y = y;
-	info->rotation = rotation;
-	info->outputs = g_ptr_array_new ();
-	
-	g_ptr_array_add (info->outputs, output);
-	
-	g_hash_table_insert (assign->info, crtc, info);
-	    
+    {
+        CrtcInfo *info = g_new0 (CrtcInfo, 1);
+
+        info->mode = mode;
+        info->x = x;
+        info->y = y;
+        info->rotation = rotation;
+        info->scale = scale;
+        info->outputs = g_ptr_array_new ();
+
+        g_ptr_array_add (info->outputs, output);
+
+        g_hash_table_insert (assign->info, crtc, info);
+
         if (primary && !assign->primary)
         {
             assign->primary = output;
         }
 
-	return TRUE;
+        return TRUE;
     }
+
+    return FALSE;
 }
 
 static void
@@ -1590,8 +1798,60 @@ typedef struct {
     guint32 timestamp;
     gboolean has_error;
     GError **error;
+    guint global_scale;
 } ConfigureCrtcState;
 
+// static guint
+// get_max_info_scale (CrtcAssignment *assignment)
+// {
+//     GList *infos, *iter;
+//     float max_scale = 0;
+
+//     infos = g_hash_table_get_values (assignment->info);
+
+//     for (iter = infos; iter != NULL; iter = iter->next)
+//     {
+//         CrtcInfo *info = iter->data;
+
+//         if (info->scale > max_scale)
+//         {
+//             max_scale = info->scale;
+//         }
+//     }
+
+//     g_list_free (infos);
+
+
+//     return CLAMP ((guint) ceilf (max_scale),
+//                   MINIMUM_GLOBAL_SCALE_FACTOR,
+//                   MAXIMUM_GLOBAL_SCALE_FACTOR);
+// }
+
+// static guint
+// get_min_info_scale (CrtcAssignment *assignment)
+// {
+//     GList *infos, *iter;
+//     float min_scale = 4.0f;
+
+//     infos = g_hash_table_get_values (assignment->info);
+
+//     for (iter = infos; iter != NULL; iter = iter->next)
+//     {
+//         CrtcInfo *info = iter->data;
+
+//         if (info->scale < min_scale)
+//         {
+//             min_scale = info->scale;
+//         }
+//     }
+
+//     g_list_free (infos);
+
+//     return CLAMP ((guint) floorf (min_scale),
+//                   MINIMUM_GLOBAL_SCALE_FACTOR,
+//                   MAXIMUM_GLOBAL_SCALE_FACTOR);
+// }
+
 static void
 configure_crtc (gpointer key,
 		gpointer value,
@@ -1611,6 +1871,8 @@ configure_crtc (gpointer key,
 					     info->rotation,
 					     (GnomeRROutput **)info->outputs->pdata,
 					     info->outputs->len,
+                         info->scale,
+                         state->global_scale,
 					     state->error))
 	state->has_error = TRUE;
 }
@@ -1669,13 +1931,14 @@ real_assign_crtcs (GnomeRRScreen *screen
     gboolean success;
 
     output = *outputs;
+
     if (!output)
-	return TRUE;
+        return TRUE;
 
     /* It is always allowed for an output to be turned off */
     if (!output->priv->on)
     {
-	return real_assign_crtcs (screen, outputs + 1, assignment, error);
+        return real_assign_crtcs (screen, outputs + 1, assignment, error);
     }
 
     success = FALSE;
@@ -1684,69 +1947,73 @@ real_assign_crtcs (GnomeRRScreen *screen
 
     for (i = 0; crtcs[i] != NULL; ++i)
     {
-	GnomeRRCrtc *crtc = crtcs[i];
-	int crtc_id = gnome_rr_crtc_get_id (crtc);
-	int pass;
-
-	g_string_append_printf (accumulated_error,
-				_("Trying modes for CRTC %d\n"),
-				crtc_id);
-
-	/* Make two passes, one where frequencies must match, then
-	 * one where they don't have to
-	 */
-	for (pass = 0; pass < 2; ++pass)
-	{
-	    GnomeRROutput *gnome_rr_output = gnome_rr_screen_get_output_by_name (screen, output->priv->name);
-	    GnomeRRMode **modes = gnome_rr_output_list_modes (gnome_rr_output);
-	    int j;
+        GnomeRRCrtc *crtc = crtcs[i];
+        int crtc_id = gnome_rr_crtc_get_id (crtc);
+        int pass;
+        g_debug (_("Trying modes for CRTC %d"),
+                 crtc_id);
+        g_string_append_printf (accumulated_error,
+                                _("Trying modes for CRTC %d\n"),
+                                crtc_id);
+
+        /* Make two passes, one where frequencies must match, then
+         * one where they don't have to
+         */
+        for (pass = 0; pass < 2; ++pass)
+        {
+            GnomeRROutput *gnome_rr_output = gnome_rr_screen_get_output_by_name (screen, output->priv->name);
+            GnomeRRMode **modes = gnome_rr_output_list_modes (gnome_rr_output);
+            int j;
 
-	    for (j = 0; modes[j] != NULL; ++j)
-	    {
-		GnomeRRMode *mode = modes[j];
-		int mode_width;
-		int mode_height;
-		int mode_freq;
-
-		mode_width = gnome_rr_mode_get_width (mode);
-		mode_height = gnome_rr_mode_get_height (mode);
-		mode_freq = gnome_rr_mode_get_freq (mode);
+            for (j = 0; modes[j] != NULL; ++j)
+            {
+                GnomeRRMode *mode = modes[j];
+                int mode_width;
+                int mode_height;
+                double mode_freq;
+
+                mode_width = gnome_rr_mode_get_width (mode);
+                mode_height = gnome_rr_mode_get_height (mode);
+                mode_freq = gnome_rr_mode_get_freq_f (mode);
 
-		g_string_append_printf (accumulated_error,
-					_("CRTC %d: trying mode %dx%d@%dHz with output at %dx%d@%dHz (pass %d)\n"),
+                g_string_append_printf (accumulated_error,
+					_("CRTC %d: trying mode %dx%d@%.2fHz with output at %dx%d@%.2fHz (pass %d)\n"),
 					crtc_id,
 					mode_width, mode_height, mode_freq,
 					output->priv->width, output->priv->height, output->priv->rate,
 					pass);
 
-		if (mode_width == output->priv->width	&&
-		    mode_height == output->priv->height &&
-		    (pass == 1 || mode_freq == output->priv->rate))
-		{
-		    tried_mode = TRUE;
-
-		    my_error = NULL;
-		    if (crtc_assignment_assign (
-			    assignment, crtc, modes[j],
-			    output->priv->x, output->priv->y,
-			    output->priv->rotation,
-                            output->priv->primary,
-			    gnome_rr_output,
-			    &my_error))
-		    {
-			my_error = NULL;
-			if (real_assign_crtcs (screen, outputs + 1, assignment, &my_error)) {
-			    success = TRUE;
-			    goto out;
-			} else
-			    accumulate_error (accumulated_error, my_error);
-
-			crtc_assignment_unassign (assignment, crtc, gnome_rr_output);
-		    } else
-			accumulate_error (accumulated_error, my_error);
-		}
-	    }
-	}
+                if (mode_width == output->priv->width	&&
+                    mode_height == output->priv->height &&
+                    (pass == 1 || mode_freq == output->priv->rate))
+                {
+                    tried_mode = TRUE;
+
+                    my_error = NULL;
+
+                    if (crtc_assignment_assign (
+                        assignment, crtc, modes[j],
+                        output->priv->x, output->priv->y,
+                        output->priv->rotation,
+                        output->priv->primary,
+                        output->priv->scale,
+                        gnome_rr_output,
+                        &my_error))
+                    {
+                        my_error = NULL;
+                        
+                        if (real_assign_crtcs (screen, outputs + 1, assignment, &my_error)) {
+                            success = TRUE;
+                            goto out;
+                        } else
+                            accumulate_error (accumulated_error, my_error);
+
+                        crtc_assignment_unassign (assignment, crtc, gnome_rr_output);
+                    } else
+                        accumulate_error (accumulated_error, my_error);
+                }
+            }
+        }
     }
 
 out:
@@ -1781,44 +2048,72 @@ crtc_info_free (CrtcInfo *info)
 }
 
 static void
-get_required_virtual_size (CrtcAssignment *assign, int *width, int *height)
+get_required_virtual_size (CrtcAssignment *assign,
+                           GnomeRRScreen  *screen,
+                           int            *width,
+                           int            *height,
+                           float          *avg_scale,
+                           guint          *global_scale)
 {
     GList *active_crtcs = g_hash_table_get_keys (assign->info);
     GList *list;
-    int d;
+    int d, crtc_count;
+    float df;
+    float avg_screen_scale;
+
+/*
+    if (gnome_rr_screen_get_use_upscaling (screen))
+    {
+        *global_scale = get_min_info_scale (assign);
+    }
+    else
+    {
+        *global_scale = get_max_info_scale (assign);
+    }
+*/
 
-    if (!width)
-	width = &d;
-    if (!height)
-	height = &d;
-    
     /* Compute size of the screen */
     *width = *height = 1;
+    avg_screen_scale = 0;
+    crtc_count = 0;
     for (list = active_crtcs; list != NULL; list = list->next)
     {
-	GnomeRRCrtc *crtc = list->data;
-	CrtcInfo *info = g_hash_table_lookup (assign->info, crtc);
-	int w, h;
+        GnomeRRCrtc *crtc = list->data;
+        CrtcInfo *info = g_hash_table_lookup (assign->info, crtc);
+        int w, h;
+        float scale = 1.0f;
 
-	w = gnome_rr_mode_get_width (info->mode);
-	h = gnome_rr_mode_get_height (info->mode);
-	
-	if (mode_is_rotated (info))
-	{
-	    int tmp = h;
-	    h = w;
-	    w = tmp;
-	}
-	
-	*width = MAX (*width, info->x + w);
-	*height = MAX (*height, info->y + h);
+        scale = *global_scale / info->scale;
+
+        w = gnome_rr_mode_get_width (info->mode);
+        h = gnome_rr_mode_get_height (info->mode);
+
+        if (mode_is_rotated (info))
+        {
+            int tmp = h;
+            h = w;
+            w = tmp;
+        }
+
+        *width = MAX (*width, info->x + roundf (w * scale));
+        *height = MAX (*height, info->y + roundf (h * scale));
+
+        avg_screen_scale += (info->scale - avg_screen_scale) / (float) (++crtc_count);
     }
 
+    *avg_scale = avg_screen_scale;
+
+    g_debug ("Proposed screen size: %dx%d average scale: %.2f, ui scale: %d",
+             *width, *height, *avg_scale, *global_scale);
+
     g_list_free (active_crtcs);
 }
 
 static CrtcAssignment *
-crtc_assignment_new (GnomeRRScreen *screen, GnomeRROutputInfo **outputs, GError **error)
+crtc_assignment_new (GnomeRRConfig      *config,
+                     GnomeRRScreen      *screen,
+                     GnomeRROutputInfo **outputs,
+                     GError            **error)
 {
     CrtcAssignment *assignment = g_new0 (CrtcAssignment, 1);
 
@@ -1829,8 +2124,13 @@ crtc_assignment_new (GnomeRRScreen *scre
     {
 	int width, height;
 	int min_width, max_width, min_height, max_height;
+    float scale;
+    guint global_scale = config->priv->base_scale;
 
-	get_required_virtual_size (assignment, &width, &height);
+	get_required_virtual_size (assignment,
+                               screen,
+                               &width, &height,
+                               &scale, &global_scale);
 
 	gnome_rr_screen_get_ranges (
 	    screen, &min_width, &max_width, &min_height, &max_height);
@@ -1862,17 +2162,24 @@ fail:
 }
 
 static gboolean
-crtc_assignment_apply (CrtcAssignment *assign, guint32 timestamp, GError **error)
+crtc_assignment_apply (CrtcAssignment *assign,
+                       guint32         timestamp,
+                       GError        **error,
+                       guint          *global_scale)
 {
     GnomeRRCrtc **all_crtcs = gnome_rr_screen_list_crtcs (assign->screen);
     int width, height;
     int i;
     int min_width, max_width, min_height, max_height;
     int width_mm, height_mm;
+    float average_scale;
     gboolean success = TRUE;
 
     /* Compute size of the screen */
-    get_required_virtual_size (assign, &width, &height);
+    get_required_virtual_size (assign,
+                               assign->screen,
+                               &width, &height,
+                               &average_scale, global_scale);
 
     gnome_rr_screen_get_ranges (
 	assign->screen, &min_width, &max_width, &min_height, &max_height);
@@ -1904,13 +2211,12 @@ crtc_assignment_apply (CrtcAssignment *a
 	int x, y;
 
 	if (mode)
-	{
+    {
 	    int w, h;
 	    gnome_rr_crtc_get_position (crtc, &x, &y);
 
-	    w = gnome_rr_mode_get_width (mode);
-	    h = gnome_rr_mode_get_height (mode);
-
+	    w = gnome_rr_mode_get_width (mode) * (*global_scale);
+	    h = gnome_rr_mode_get_height (mode) * (*global_scale);
 	    if (crtc_is_rotated (crtc))
 	    {
 		int tmp = h;
@@ -1918,9 +2224,18 @@ crtc_assignment_apply (CrtcAssignment *a
 		w = tmp;
 	    }
 	    
-	    if (x + w > width || y + h > height || !g_hash_table_lookup (assign->info, crtc))
+	    if (!x + w > width || y + h > height || g_hash_table_lookup (assign->info, crtc))
 	    {
-		if (!gnome_rr_crtc_set_config_with_time (crtc, timestamp, 0, 0, NULL, GNOME_RR_ROTATION_0, NULL, 0, error))
+		if (!gnome_rr_crtc_set_config_with_time (crtc,
+                                                 timestamp,
+                                                 0, 0,
+                                                 NULL,
+                                                 GNOME_RR_ROTATION_0,
+                                                 NULL,
+                                                 0,
+                                                 1.0f,
+                                                 1,
+                                                 error))
 		{
 		    success = FALSE;
 		    break;
@@ -1936,22 +2251,22 @@ crtc_assignment_apply (CrtcAssignment *a
      *
      * Firefox and Evince apparently believe what X tells them.
      */
-    width_mm = (width / DPI_FALLBACK) * 25.4 + 0.5;
-    height_mm = (height / DPI_FALLBACK) * 25.4 + 0.5;
+    width_mm = (width / (DPI_FALLBACK / average_scale)) * 25.4 + 0.5;
+    height_mm = (height / (DPI_FALLBACK / average_scale)) * 25.4 + 0.5;
 
     if (success)
     {
-	ConfigureCrtcState state;
+        ConfigureCrtcState state;
 
-	gnome_rr_screen_set_size (assign->screen, width, height, width_mm, height_mm);
+        state.timestamp = timestamp;
+        state.has_error = FALSE;
+        state.error = error;
+        state.global_scale = *global_scale;
+        gnome_rr_screen_set_size (assign->screen, width, height, width_mm, height_mm);
 
-	state.timestamp = timestamp;
-	state.has_error = FALSE;
-	state.error = error;
-	
-	g_hash_table_foreach (assign->info, configure_crtc, &state);
+        g_hash_table_foreach (assign->info, configure_crtc, &state);
 
-	success = !state.has_error;
+        success = !state.has_error;
     }
 
     gnome_rr_screen_set_primary_output (assign->screen, assign->primary);
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr-config.h 4.6.2-1/libcinnamon-desktop/gnome-rr-config.h
--- 4.4.1-3/libcinnamon-desktop/gnome-rr-config.h	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr-config.h	2020-06-21 12:35:34.000000000 +0000
@@ -59,7 +59,7 @@ typedef struct
 
 GType gnome_rr_output_info_get_type (void);
 
-char *gnome_rr_output_info_get_name (GnomeRROutputInfo *self);
+const char *gnome_rr_output_info_get_name (GnomeRROutputInfo *self);
 
 gboolean gnome_rr_output_info_is_active  (GnomeRROutputInfo *self);
 void     gnome_rr_output_info_set_active (GnomeRROutputInfo *self, gboolean active);
@@ -67,9 +67,15 @@ void     gnome_rr_output_info_set_active
 void gnome_rr_output_info_get_geometry (GnomeRROutputInfo *self, int *x, int *y, int *width, int *height);
 void gnome_rr_output_info_set_geometry (GnomeRROutputInfo *self, int  x, int  y, int  width, int  height);
 
-int  gnome_rr_output_info_get_refresh_rate (GnomeRROutputInfo *self);
+float gnome_rr_output_info_get_scale (GnomeRROutputInfo *self);
+void gnome_rr_output_info_set_scale (GnomeRROutputInfo *self, float scale);
+
+int gnome_rr_output_info_get_refresh_rate (GnomeRROutputInfo *self);
 void gnome_rr_output_info_set_refresh_rate (GnomeRROutputInfo *self, int rate);
 
+double gnome_rr_output_info_get_refresh_rate_f (GnomeRROutputInfo *self);
+void gnome_rr_output_info_set_refresh_rate_f (GnomeRROutputInfo *self, double rate);
+
 GnomeRRRotation gnome_rr_output_info_get_rotation (GnomeRROutputInfo *self);
 void            gnome_rr_output_info_set_rotation (GnomeRROutputInfo *self, GnomeRRRotation rotation);
 
@@ -86,6 +92,14 @@ void     gnome_rr_output_info_set_primar
 int gnome_rr_output_info_get_preferred_width  (GnomeRROutputInfo *self);
 int gnome_rr_output_info_get_preferred_height (GnomeRROutputInfo *self);
 
+void gnome_rr_output_info_get_flags (GnomeRROutputInfo *self,
+                                     gboolean          *doublescan,
+                                     gboolean          *interlaced,
+                                     gboolean          *vsync);
+void gnome_rr_output_info_set_flags (GnomeRROutputInfo *self,
+                                     gboolean           doublescan,
+                                     gboolean           interlaced,
+                                     gboolean           vsync);
 typedef struct
 {
     GObject parent;
@@ -142,9 +156,16 @@ gboolean            gnome_rr_config_appl
 
 gboolean            gnome_rr_config_get_clone    (GnomeRRConfig  *configuration);
 void                gnome_rr_config_set_clone    (GnomeRRConfig  *configuration, gboolean clone);
+guint               gnome_rr_config_get_base_scale (GnomeRRConfig *self);
+void                gnome_rr_config_set_base_scale (GnomeRRConfig *self,
+                                                    guint base_scale);
+gboolean            gnome_rr_config_get_auto_scale (GnomeRRConfig *self);
+void                gnome_rr_config_set_auto_scale (GnomeRRConfig *self,
+                                                    gboolean       auto_scale);
 GnomeRROutputInfo **gnome_rr_config_get_outputs  (GnomeRRConfig  *configuration);
 
 char *gnome_rr_config_get_backup_filename (void);
 char *gnome_rr_config_get_intended_filename (void);
+char *gnome_rr_config_get_legacy_filename (void);
 
 #endif
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr.h 4.6.2-1/libcinnamon-desktop/gnome-rr.h
--- 4.4.1-3/libcinnamon-desktop/gnome-rr.h	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr.h	2020-06-21 12:35:34.000000000 +0000
@@ -144,6 +144,17 @@ gboolean        gnome_rr_screen_get_dpms
 gboolean        gnome_rr_screen_set_dpms_mode      (GnomeRRScreen         *screen,
                                                     GnomeRRDpmsMode        mode,
                                                     GError              **error);
+guint             gnome_rr_screen_get_global_scale (GnomeRRScreen   *screen);
+guint             gnome_rr_screen_get_global_scale_setting (GnomeRRScreen   *screen);
+void            gnome_rr_screen_set_global_scale_setting (GnomeRRScreen   *screen,
+                                                    guint            scale_factor);
+gboolean        gnome_rr_screen_get_use_upscaling  (GnomeRRScreen        *screen);
+float *         gnome_rr_screen_calculate_supported_scales (GnomeRRScreen     *screen,
+                                                            int                width,
+                                                            int                height,
+                                                            int               *n_supported_scales);
+/* screen class method, used in csd-xsettings and here */
+guint             gnome_rr_screen_calculate_best_global_scale (GnomeRRScreen *screen, gint index);
 
 /* GnomeRROutput */
 guint32         gnome_rr_output_get_id             (GnomeRROutput         *output);
@@ -188,7 +199,11 @@ guint32         gnome_rr_mode_get_id
 guint           gnome_rr_mode_get_width            (GnomeRRMode           *mode);
 guint           gnome_rr_mode_get_height           (GnomeRRMode           *mode);
 int             gnome_rr_mode_get_freq             (GnomeRRMode           *mode);
-
+double          gnome_rr_mode_get_freq_f           (GnomeRRMode           *mode);
+void            gnome_rr_mode_get_flags            (GnomeRRMode           *mode,
+                                                    gboolean              *doublescan,
+                                                    gboolean              *interlaced,
+                                                    gboolean              *vsync);
 /* GnomeRRCrtc */
 guint32         gnome_rr_crtc_get_id               (GnomeRRCrtc           *crtc);
 
@@ -200,6 +215,8 @@ gboolean        gnome_rr_crtc_set_config
 						    GnomeRRRotation        rotation,
 						    GnomeRROutput        **outputs,
 						    int                    n_outputs,
+                            float                  scale,
+                            guint                  global_scale,
 						    GError               **error);
 gboolean        gnome_rr_crtc_can_drive_output     (GnomeRRCrtc           *crtc,
 						    GnomeRROutput         *output);
@@ -207,6 +224,7 @@ GnomeRRMode *   gnome_rr_crtc_get_curren
 void            gnome_rr_crtc_get_position         (GnomeRRCrtc           *crtc,
 						    int                   *x,
 						    int                   *y);
+float           gnome_rr_crtc_get_scale            (GnomeRRCrtc           *crtc);
 GnomeRRRotation gnome_rr_crtc_get_current_rotation (GnomeRRCrtc           *crtc);
 GnomeRRRotation gnome_rr_crtc_get_rotations        (GnomeRRCrtc           *crtc);
 gboolean        gnome_rr_crtc_supports_rotation    (GnomeRRCrtc           *crtc,
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr-output-info.c 4.6.2-1/libcinnamon-desktop/gnome-rr-output-info.c
--- 4.4.1-3/libcinnamon-desktop/gnome-rr-output-info.c	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr-output-info.c	2020-06-21 12:35:34.000000000 +0000
@@ -40,6 +40,7 @@ gnome_rr_output_info_init (GnomeRROutput
     self->priv->name = NULL;
     self->priv->on = FALSE;
     self->priv->display_name = NULL;
+    self->priv->scale = 1;
 }
 
 static void
@@ -68,7 +69,7 @@ gnome_rr_output_info_class_init (GnomeRR
  *
  * Returns: (transfer none): the output name
  */
-char *gnome_rr_output_info_get_name (GnomeRROutputInfo *self)
+const char *gnome_rr_output_info_get_name (GnomeRROutputInfo *self)
 {
     g_return_val_if_fail (GNOME_IS_RR_OUTPUT_INFO (self), NULL);
 
@@ -126,17 +127,45 @@ void gnome_rr_output_info_set_geometry (
     self->priv->height = height;
 }
 
+float gnome_rr_output_info_get_scale (GnomeRROutputInfo *self)
+{
+    g_return_val_if_fail (GNOME_IS_RR_OUTPUT_INFO (self), MINIMUM_LOGICAL_SCALE_FACTOR);
+
+    return self->priv->scale;
+}
+
+void gnome_rr_output_info_set_scale (GnomeRROutputInfo *self, float scale)
+{
+    g_return_if_fail (GNOME_IS_RR_OUTPUT_INFO (self));
+
+    self->priv->scale = scale;
+}
+
 int gnome_rr_output_info_get_refresh_rate (GnomeRROutputInfo *self)
 {
     g_return_val_if_fail (GNOME_IS_RR_OUTPUT_INFO (self), 0);
 
-    return self->priv->rate;
+    return (int) self->priv->rate;
 }
 
 void gnome_rr_output_info_set_refresh_rate (GnomeRROutputInfo *self, int rate)
 {
     g_return_if_fail (GNOME_IS_RR_OUTPUT_INFO (self));
 
+    self->priv->rate = rate * 1.0;
+}
+
+double gnome_rr_output_info_get_refresh_rate_f (GnomeRROutputInfo *self)
+{
+    g_return_val_if_fail (GNOME_IS_RR_OUTPUT_INFO (self), 0);
+
+    return self->priv->rate;
+}
+
+void gnome_rr_output_info_set_refresh_rate_f (GnomeRROutputInfo *self, double rate)
+{
+    g_return_if_fail (GNOME_IS_RR_OUTPUT_INFO (self));
+
     self->priv->rate = rate;
 }
 
@@ -154,6 +183,33 @@ void gnome_rr_output_info_set_rotation (
     self->priv->rotation = rotation;
 }
 
+void gnome_rr_output_info_get_flags (GnomeRROutputInfo *self,
+                                     gboolean          *doublescan,
+                                     gboolean          *interlaced,
+                                     gboolean          *vsync)
+{
+    g_return_if_fail (GNOME_IS_RR_OUTPUT_INFO (self));
+
+    if (doublescan)
+        *doublescan = self->priv->doublescan;
+    if (interlaced)
+        *interlaced = self->priv->interlaced;
+    if (vsync)
+        *vsync = self->priv->vsync;
+}
+
+void gnome_rr_output_info_set_flags (GnomeRROutputInfo *self,
+                                     gboolean           doublescan,
+                                     gboolean           interlaced,
+                                     gboolean           vsync)
+{
+    g_return_if_fail (GNOME_IS_RR_OUTPUT_INFO (self));
+
+    self->priv->doublescan = doublescan;
+    self->priv->interlaced = interlaced;
+    self->priv->vsync = vsync;
+}
+
 /**
  * gnome_rr_output_info_is_connected:
  *
diff -pruN 4.4.1-3/libcinnamon-desktop/gnome-rr-private.h 4.6.2-1/libcinnamon-desktop/gnome-rr-private.h
--- 4.4.1-3/libcinnamon-desktop/gnome-rr-private.h	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/libcinnamon-desktop/gnome-rr-private.h	2020-06-21 12:35:34.000000000 +0000
@@ -5,6 +5,11 @@
 
 #include <X11/extensions/Xrandr.h>
 
+#define MINIMUM_LOGICAL_SCALE_FACTOR 0.74f
+#define MAXIMUM_LOGICAL_SCALE_FACTOR 2.0f
+#define MINIMUM_GLOBAL_SCALE_FACTOR 1
+#define MAXIMUM_GLOBAL_SCALE_FACTOR 2
+
 typedef struct ScreenInfo ScreenInfo;
 
 struct ScreenInfo
@@ -35,6 +40,7 @@ struct GnomeRRScreenPrivate
     Screen *			xscreen;
     Window			xroot;
     ScreenInfo *		info;
+    GSettings *         interface_settings;
     
     int				randr_event_base;
     int				rr_major_version;
@@ -51,7 +57,7 @@ struct GnomeRROutputInfoPrivate
     gboolean		on;
     int			width;
     int			height;
-    int			rate;
+    double		rate;
     int			x;
     int			y;
     GnomeRRRotation	rotation;
@@ -65,6 +71,10 @@ struct GnomeRROutputInfoPrivate
     int			pref_height;
     char *		display_name;
     gboolean            primary;
+    float       scale;
+    gboolean    doublescan;
+    gboolean    interlaced;
+    gboolean    vsync;
 };
 
 struct GnomeRRConfigPrivate
@@ -72,6 +82,8 @@ struct GnomeRRConfigPrivate
   gboolean clone;
   GnomeRRScreen *screen;
   GnomeRROutputInfo **outputs;
+  guint base_scale;
+  gboolean auto_scale;
 };
 
 gboolean _gnome_rr_output_name_is_laptop (const char *name);
diff -pruN 4.4.1-3/meson.build 4.6.2-1/meson.build
--- 4.4.1-3/meson.build	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/meson.build	2020-06-21 12:35:34.000000000 +0000
@@ -1,7 +1,7 @@
 # Meson build file
 
 # https://github.com/linuxmint/cinnamon-desktop
-project('cinnamon-desktop', 'c', version: '4.4.1',
+project('cinnamon-desktop', 'c', version: '4.6.2',
   meson_version: '>=0.41.0'
 )
 
diff -pruN 4.4.1-3/schemas/org.cinnamon.desktop.interface.gschema.xml.in.in 4.6.2-1/schemas/org.cinnamon.desktop.interface.gschema.xml.in.in
--- 4.4.1-3/schemas/org.cinnamon.desktop.interface.gschema.xml.in.in	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/schemas/org.cinnamon.desktop.interface.gschema.xml.in.in	2020-06-21 12:35:34.000000000 +0000
@@ -161,6 +161,13 @@
    0 means pick automatically based on monitor.
       </_description>
     </key>
+    <key name="upscale-fractional-scaling" type="b">
+      <default>false</default>
+      <_summary>Achieve fractional scaling by scaling up.</_summary>
+      <_description>
+        Fractional scaling is usually achieved by setting the global scale factor to a higher value and then scaling down.  Scaling up instead yields better performance but poorer quality - in certain configurations and hardware, this may be acceptable.
+      </_description>
+    </key>
     <key name="gtk-im-status-style" type="s">
       <default>'callback'</default>
       <_summary>GTK IM Status Style</_summary>
diff -pruN 4.4.1-3/schemas/org.cinnamon.desktop.screensaver.gschema.xml.in.in 4.6.2-1/schemas/org.cinnamon.desktop.screensaver.gschema.xml.in.in
--- 4.4.1-3/schemas/org.cinnamon.desktop.screensaver.gschema.xml.in.in	2019-12-12 11:02:11.000000000 +0000
+++ 4.6.2-1/schemas/org.cinnamon.desktop.screensaver.gschema.xml.in.in	2020-06-21 12:35:34.000000000 +0000
@@ -139,5 +139,10 @@
       <_summary>Keyboard layout group to use when entering your password</_summary>
       <_description>This stores the last active keyboard layout group for entering your password.</_description>
     </key>
+    <key name="custom-screensaver-command" type="s">
+      <default>""</default>
+      <summary>Specify custom screen locker command</summary>
+      <description>If empty, cinnamon-screensaver will be used</description>
+    </key>
   </schema>
 </schemalist>
